pragma Ada_95;
pragma Warnings (Off);
pragma Source_File_Name (zlib_adamain, Spec_File_Name => "b~zlib_ada.ads");
pragma Source_File_Name (zlib_adamain, Body_File_Name => "b~zlib_ada.adb");
pragma Suppress (Overflow_Check);
with Ada.Exceptions;

package body zlib_adamain is

   E016 : Short_Integer; pragma Import (Ada, E016, "system__soft_links_E");
   E026 : Short_Integer; pragma Import (Ada, E026, "system__exception_table_E");
   E083 : Short_Integer; pragma Import (Ada, E083, "ada__io_exceptions_E");
   E054 : Short_Integer; pragma Import (Ada, E054, "ada__tags_E");
   E082 : Short_Integer; pragma Import (Ada, E082, "ada__streams_E");
   E067 : Short_Integer; pragma Import (Ada, E067, "interfaces__c_E");
   E069 : Short_Integer; pragma Import (Ada, E069, "interfaces__c__strings_E");
   E028 : Short_Integer; pragma Import (Ada, E028, "system__exceptions_E");
   E085 : Short_Integer; pragma Import (Ada, E085, "system__finalization_root_E");
   E080 : Short_Integer; pragma Import (Ada, E080, "ada__finalization_E");
   E079 : Short_Integer; pragma Import (Ada, E079, "system__storage_pools_E");
   E089 : Short_Integer; pragma Import (Ada, E089, "system__finalization_masters_E");
   E087 : Short_Integer; pragma Import (Ada, E087, "system__storage_pools__subpools_E");
   E097 : Short_Integer; pragma Import (Ada, E097, "system__pool_global_E");
   E020 : Short_Integer; pragma Import (Ada, E020, "system__secondary_stack_E");
   E002 : Short_Integer; pragma Import (Ada, E002, "zlib_E");
   E004 : Short_Integer; pragma Import (Ada, E004, "zlib__streams_E");
   E006 : Short_Integer; pragma Import (Ada, E006, "zlib__thin_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      E002 := E002 - 1;
      E004 := E004 - 1;
      declare
         procedure F1;
         pragma Import (Ada, F1, "zlib__streams__finalize_spec");
      begin
         if E004 = 0 then
            F1;
         end if;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "zlib__finalize_spec");
      begin
         if E002 = 0 then
            F2;
         end if;
      end;
      E089 := E089 - 1;
      E087 := E087 - 1;
      E097 := E097 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "system__pool_global__finalize_spec");
      begin
         if E097 = 0 then
            F3;
         end if;
      end;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__storage_pools__subpools__finalize_spec");
      begin
         if E087 = 0 then
            F4;
         end if;
      end;
      declare
         procedure F5;
         pragma Import (Ada, F5, "system__finalization_masters__finalize_spec");
      begin
         if E089 = 0 then
            F5;
         end if;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure zlib_adafinal is

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      finalize_library;
   end zlib_adafinal;

   type No_Param_Proc is access procedure;

   procedure zlib_adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      if E016 = 0 then
         System.Soft_Links'Elab_Spec;
      end if;
      if E026 = 0 then
         System.Exception_Table'Elab_Body;
      end if;
      E026 := E026 + 1;
      if E083 = 0 then
         Ada.Io_Exceptions'Elab_Spec;
      end if;
      E083 := E083 + 1;
      if E054 = 0 then
         Ada.Tags'Elab_Spec;
      end if;
      if E082 = 0 then
         Ada.Streams'Elab_Spec;
      end if;
      E082 := E082 + 1;
      if E067 = 0 then
         Interfaces.C'Elab_Spec;
      end if;
      if E069 = 0 then
         Interfaces.C.Strings'Elab_Spec;
      end if;
      if E028 = 0 then
         System.Exceptions'Elab_Spec;
      end if;
      E028 := E028 + 1;
      if E085 = 0 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E085 := E085 + 1;
      if E080 = 0 then
         Ada.Finalization'Elab_Spec;
      end if;
      E080 := E080 + 1;
      if E079 = 0 then
         System.Storage_Pools'Elab_Spec;
      end if;
      E079 := E079 + 1;
      if E089 = 0 then
         System.Finalization_Masters'Elab_Spec;
      end if;
      if E087 = 0 then
         System.Storage_Pools.Subpools'Elab_Spec;
      end if;
      if E097 = 0 then
         System.Pool_Global'Elab_Spec;
      end if;
      E097 := E097 + 1;
      E087 := E087 + 1;
      if E089 = 0 then
         System.Finalization_Masters'Elab_Body;
      end if;
      E089 := E089 + 1;
      E069 := E069 + 1;
      E067 := E067 + 1;
      if E054 = 0 then
         Ada.Tags'Elab_Body;
      end if;
      E054 := E054 + 1;
      if E016 = 0 then
         System.Soft_Links'Elab_Body;
      end if;
      E016 := E016 + 1;
      if E020 = 0 then
         System.Secondary_Stack'Elab_Body;
      end if;
      E020 := E020 + 1;
      if E002 = 0 then
         Zlib'Elab_Spec;
      end if;
      if E004 = 0 then
         Zlib.Streams'Elab_Spec;
      end if;
      E004 := E004 + 1;
      if E006 = 0 then
         Zlib.Thin'Elab_Body;
      end if;
      E006 := E006 + 1;
      E002 := E002 + 1;
   end zlib_adainit;

--  BEGIN Object file/option list
   --   ./zlib-streams.o
   --   ./zlib-thin.o
   --   ./zlib.o
   --   -L./
   --   -L/builddir/build/BUILD/zlib-ada/ppc64/
   --   -L/usr/lib/gcc/ppc64-redhat-linux/6.0.0/adalib/
   --   -static
   --   -lgnat
--  END Object file/option list   

end zlib_adamain;
